(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                DasmXms.TPU                                         
                -----------                                         
                                                                            
   Cette unit permet d'utiliser un cran texte en 16 couleurs virtuel      
 d'une largeur de 80 caractres et d'une hauteur INFINI (avec 64Mo de RAM : 
 64 000 000 octets XMS / 96 octets = 666 666 lignes, c'est dj pas mal)    
   Vous trouverez dans cette unit toutes les procdures que sont ncessai- 
 res  l'criture et affichage d'un tel cran (pour l'instant cette unit ne
 possde que les principales procdures).                                   
                                                                            
****************************************************************************
******** Pour plus informations consultez le fichier 'DesAsm.txt' **********
****************************************************************************
*)

unit DasmXms;

{}
                               {} INTERFACE {}
{}

{$G+: Utilise les fonctions du 286 : SHL & SHR (multiplication ultra rapide) }
{$X+: Ne demande pas obligatoirement de variable pour stocker un rsultat }

uses
  Clavier,    { Pour le clavier (LitTouche) }
  Convert,    { Pour l'affichage en hexadcimal }
  EcranTxt,   { Pour l'cran texte (utilis par LibereMem) }
  Xms;        { Pour la mmoire tendue (XMS) }

const
  { Position }
  NbrCodeMachMax = 15;      { NomvreX du code assembleur }
  NbrChAsm = 38;       { X du code assembleur }

  CodeAsmX = NbrCodeMachMax*2;       { X du code assembleur }
  PosFichX = CodeAsmX+NbrChAsm;   { X de la position dans le fichier }

type
  LigneXms = record
    NbrCodeMachine: byte;
    CodeMachine: array[0..NbrCodeMachMax-1] of byte;
    Txt{+Coul}: array[0..NbrChAsm*2-1] of byte;
    PosFich: LongInt;
  end;

  { Tampon }
  TypeTampon = array[0..$FFFE] of byte;
  PtrTampon  = ^TypeTampon;


const
  OfsLigneXmsMach = 1;
  OfsLigneXmsTxt  = OfsLigneXmsMach+NbrCodeMachMax;
  OfsLigneXmsPosF = OfsLigneXmsTxt+NbrChAsm*2;

  { Tampon }
  OfsTamponDessineEcran = SizeOf(LigneXms)*25;   { Offset du tampon o est   }
                                                 { dessin l'cran XMS temp. }
  OfsTamponLibre = OfsTamponDessineEcran+4000;   { Offset du tampon  partir }
                                                 { duquel il est libre       }

                       { Utilisation         Exemples            }
                       {  }
  CoulOfst =  3;       { Offset              DI,SI,...           }
  CoulComm =  7;       { Commentaire         byte ptr,near,short }
  CoulSegm =  9;       { Segment             DS,ES,GS,...        }
  CoulReg  = 10;       { Registres           AX,EBX,BP,...       }
  CoulImm  = 11;       { Immdiates          0,52,-689,...       }
  CoulInco = 12;       { Fonction inconnues  (???)               }
  CoulPos  = 13;       { Position ds le fich 10245               }
  CoulMach = 14;       { Code machine        B2C057F68E08A       }
  CoulFonc = 15;       { Fonctions           MOV,PUSH,...        }

var
  { Tampon }
  Tampon : record        { Tampon  tout faire (affichage de texte, lecture }
    Debut,               { Position de dbut du texte dans le tampon }
    Long,                { Longueur du texte }
    Ofst,                { Offset (dplacement) du tampon }
    Max   : word;        { Offset maximum du tampon }
    Charge: Boolean;     { Le tampon est en mmoire ? }
    Src   : PtrTampon;   { Tampon de 65Ko de lecture }
  end;

  { XMS }
  EcranXmsHandle: word;       { Tampon XMS d'un cran o sera dsassembl }
                        { l'excutable }
  EcranXmsCharge: boolean;   { Etat du chargement en mmoire de ce tampon }
  NbrLigneEcranXms: LongInt;
  erreur: word;

  { Ecran }
  EcranY: LongInt;
  EcranX: Byte;
  CoulTxt: byte;

  { Ecran }
  CodeMachI: byte;

procedure TestErreurXms (txt: string);
procedure LibereMemAlloue; var X: byte;

Procedure CoulTexte (coul: byte);
Procedure CoulFond (coul: byte);

{ Ecriture d'un texte. Pour personnaliser l'criture, voici des options : }
{ h -> rpete un caractre Horizontalement }
{ x -> indique les coordonnes X et y dy texte }
{ r -> Retour  la ligne }
{ c -> indique la Couleur du texte }
Procedure EcriM   (txt: string);
Procedure EcriMc  (txt: string; coul: byte);
Procedure EcriMr  (txt: string);
Procedure EcriMcr (txt: string; coul: byte);
Procedure EcriMx  (x: shortint; y: LongInt; txt: string);
Procedure EcriMxc (x: shortint; y: LongInt; txt: string; coul: byte);
procedure EcriMh  (NRepetition: byte; Ch: char);
procedure EcriMhc (NRepetition: byte; Ch: char; coul: byte);

{ Colorie une ligne }
procedure ColoriMh (x: byte; y: LongInt; haut,coul: byte);

procedure AfficheEcranXms (Y: LongInt);

{}
                            {} IMPLEMENTATION {}
{}

var
  index,vram: LongInt;
  ix,iy: word;
  TmpTxt: String;

procedure TestErreurXms (txt: string); begin
  if ErreurXms=0 then exit;

  EcriTxc (-1,-1,'ERREUR XMS - Pressez une touche',14+4*16); LitTouche;

  InitModeTxt;
  EcriTr ('Erreur lors de '+txt+' (n'+Hex8z(ErreurXms)+') :');
  EcriTr ('-> '+TxtErreurXms);
  EcriTr ('');
  EcriTr ('Info pour le deboggage :');
  with CopieXms do begin
    Ecrit ('Taille = '); EcriTncr (Taille,10);
    Ecrit ('SrcHdl = '); EcriTncr (SrcHdl,10);
    Ecrit ('SrcOfs = '); EcriTnc (SrcOfs,10);
    Ecrit (' ('); EcriTc (Hex16z(SrcOfs shr 16)+':'+Hex16z(SrcOfs and $FFFF),10); EcriTr (')');
    Ecrit ('DstHdl = '); EcriTncr (DstHdl,10);
    Ecrit ('DstOfs = '); EcriTnc (DstOfs,10);
    Ecrit (' ('); EcriTc (Hex16z(DstOfs shr 16)+':'+Hex16z(DstOfs and $FFFF),10); EcriTr (')');
    Ecrit ('Mmoire XMS libre = '); EcriTnc (MemXmsLibre,10); EcriTr (' Ko');
  end;
  Ecrit ('- Pressez une touche pour finir -'); LitTouche;
  EcriTxhc (0,EcranY,80,' ',7); PosX (0); LibereMemAlloue;
  Halt;
end;

procedure LibereMemAlloue; var SauveX: byte; begin
  EcriT ('Libre la mmoire alloue : '); SauveX := EcranTxt.EcranX;

  { Ecran XMS }
  if EcranXmsCharge then begin
    EcriTc ('cran XMS',11);
    RendMemXms (EcranXmsHandle);
    TestErreurXms ('la libration de l''cran XMS');
    EcranXmsCharge := FALSE;
  end;

  { Tampon }
  with Tampon do if Charge then begin
    if EcranTxt.EcranX<>SauveX then Ecrit (', ');
    EcriTc ('tampon',11);
    FreeMem (Src,$FFFF);
    Charge := FALSE;
  end;

  if EcranTxt.EcranX<>SauveX then begin
    EcriT (' -> ');
    EcriTcr ('russi !',14);
  end else EcriTr ('(rien  rendre)');
end;

Procedure CoulTexte (coul: byte); begin CoulTxt := CoulTxt and $F0 +coul and 15 end;
Procedure CoulFond  (coul: byte); begin CoulTxt := Coul shl 4   +CoulTxt and 15 end;

Procedure EcriM (txt: string); begin
  index := 0;
  for ix := 1 to length(txt) do with Tampon do begin
    Src^[index] := ord(txt[ix]); inc (index);
    Src^[index] := CoulTxt;      inc (index);
  end;

  with CopieXms do begin
    Taille := length(txt) shl 1; { =*2 -> caractre + attribut (couleur) }
    if Taille and 1=1 then inc(Taille);
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
    DstHdl := EcranXmsHandle;
    DstOfs := EcranY*SizeOf(LigneXms) +OfsLigneXmsTxt +EcranX shl 1;
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture d''un texte dans cran XMS');

  inc (EcranX,length(txt));
  while 80<EcranX do begin dec(EcranX,80); inc (EcranY) end;
end;

Procedure EcriMc (txt: string; coul: byte); begin
  index := 0;
  for ix := 1 to length(txt) do with Tampon do begin
    Src^[index] := ord(txt[ix]); inc (index);
    Src^[index] := coul;           inc (index);
  end;

  with CopieXms do begin
    Taille := length(txt) shl 1; { =*2 -> caractre + attribut (couleur) }
    if Taille and 1=1 then inc(Taille);
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
    DstHdl := EcranXmsHandle;
    DstOfs := EcranY*SizeOf(LigneXms) +OfsLigneXmsTxt +EcranX shl 1;
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture d''un texte dans cran XMS');

  inc (EcranX,length(txt));
  while 80<EcranX do begin dec(EcranX,80); inc (EcranY) end;
end;

Procedure EcriMr (txt: string); begin
  index := 0;
  for ix := 1 to length(txt) do with Tampon do begin
    Src^[index] := ord(txt[ix]); inc (index);
    Src^[index] := CoulTxt;        inc (index);
  end;

  with CopieXms do begin
    Taille := length(txt) shl 1; { =*2 -> caractre + attribut (couleur) }
    if Taille and 1=1 then inc(Taille);
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
    DstHdl := EcranXmsHandle;
    DstOfs := EcranY*SizeOf(LigneXms) +OfsLigneXmsTxt +EcranX shl 1;


  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture d''un texte R dans cran XMS');

  inc (EcranX,length(txt));
  if EcranX<80 then begin
    inc (EcranY);
    EcranX := 0;
  end else while 80<EcranX do begin dec(EcranX,80); inc (EcranY) end;
end;

Procedure EcriMcr (txt: string; coul: byte); begin
  index := 0;
  for ix := 1 to length(txt) do with Tampon do begin
    Src^[index] := ord(txt[ix]); inc (index);
    Src^[index] := coul;           inc (index);
  end;

  with CopieXms do begin
    Taille := length(txt) shl 1; { =*2 -> caractre + attribut (couleur) }
    if Taille and 1=1 then inc(Taille);
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
    DstHdl := EcranXmsHandle;
    DstOfs := EcranY*SizeOf(LigneXms) +OfsLigneXmsTxt +EcranX shl 1;
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture d''un texte R dans cran XMS');

  inc (EcranX,length(txt));
  if EcranX<80 then begin
    inc (EcranY);
    EcranX := 0;
  end else while 80<EcranX do begin dec(EcranX,80); inc (EcranY) end;
end;

Procedure EcriMx (x: shortint; y: LongInt; txt: string); begin
  if x<0 then x := (80 - length(txt)) shr 1;
  if y<0 then y := 12;

  index := 0;
  for ix := 1 to length(txt) do with Tampon do begin
    Src^[index] := ord(txt[ix]); inc (index);
    Src^[index] := CoulTxt;        inc (index);
  end;

  with CopieXms do begin
    Taille := length(txt) shl 1; { =*2 -> caractre + attribut (couleur) }
    if Taille and 1=1 then inc(Taille);
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
    DstHdl := EcranXmsHandle;
    DstOfs := Y*SizeOf(LigneXms) +OfsLigneXmsTxt +X shl 1; { Y*80*2 (cf. taille) +X }
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture d''un texte XY dans cran XMS');
end;

Procedure EcriMxc (x: shortint; y: LongInt; txt: string; coul: byte); begin
  if x<0 then x := (80 - length(txt)) shr 1;
  if y<0 then y := 12;

  index := 0;
  for ix := 1 to length(txt) do with Tampon do begin
    Src^[index] := ord(txt[ix]); inc (index);
    Src^[index] := coul;        inc (index);
  end;

  with CopieXms do begin
    Taille := length(txt) shl 1; { =*2 -> caractre + attribut (couleur) }
    if Taille and 1=1 then inc(Taille);
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
    DstHdl := EcranXmsHandle;
    DstOfs := Y;
    DstOfs := Y*SizeOf(LigneXms) +OfsLigneXmsTxt +X shl 1;
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture d''un texte XY dans cran XMS');
end;

procedure EcriMh (NRepetition: byte; Ch: char); begin
  with CopieXms do begin
    Taille := NRepetition shl 1; { =*2 -> caractre + attribut (couleur) }
    if Taille and 1=1 then inc(Taille);
    SrcHdl := EcranXmsHandle;
    SrcOfs := EcranY*SizeOf(LigneXms) +OfsLigneXmsTxt +EcranX shl 1;
    DstHdl := 0;
    DstOfs := Ptr2Long(Tampon.Src);
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture  rptition d''un caractre XMS (1/2)');

  index := 0;
  for ix := 0 to NRepetition-1 do begin
    Tampon.Src^[index] := ord(ch); inc (index);
    Tampon.Src^[index] := CoulTxt; inc (index);
  end;

  with CopieXms do begin
    DstOfs := SrcOfs;
    DstHdl := SrcHdl;
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture  rptition d''un caractre XMS (2/2)');
end;

procedure EcriMhc (NRepetition: byte; Ch: char; Coul: byte); begin
  with CopieXms do begin
    Taille := NRepetition shl 1; { =*2 -> caractre + attribut (couleur) }
    if Taille and 1=1 then inc(Taille);
    SrcHdl := EcranXmsHandle;
    SrcOfs := EcranY*SizeOf(LigneXms) +OfsLigneXmsTxt +EcranX shl 1;
    DstHdl := 0;
    DstOfs := Ptr2Long(Tampon.Src);
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture  rptition d''un caractre XMS (1/2)');

  index := 0;
  for ix := 0 to NRepetition-1 do begin
    Tampon.Src^[index] := ord(ch); inc (index);
    Tampon.Src^[index] := coul;    inc (index);
  end;

  with CopieXms do begin
    DstOfs := SrcOfs;
    DstHdl := SrcHdl;
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture  rptition d''un caractre XMS (2/2)');
end;

procedure ColoriMh (x: byte; y: LongInt; haut,coul: byte); begin
  with CopieXms do begin
    Taille := haut shl 1; { =*2 -> caractre + attribut (couleur) }
    if Taille and 1=1 then inc(Taille);
    SrcHdl := EcranXmsHandle;
    SrcOfs := Y*SizeOf(LigneXms) +OfsLigneXmsTxt +x shl 1;{ Y*80*2 (cf. taille)+X }
    DstHdl := 0;
    DstOfs := Ptr2Long(Tampon.Src);
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('coloriage horizonatale de l''cran XMS (1/2)');

  index := 1;
  for ix := 0 to haut-1 do begin
    Tampon.Src^[index] := coul;
    inc (index,2);
  end;

  with CopieXms do begin
    DstOfs := SrcOfs;
    DstHdl := SrcHdl;
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('coloriage horizonatale de l''cran XMS (2/2)');
end;

procedure AfficheEcranXms (Y: LongInt); var CoulF: byte; begin
  with CopieXms do begin
    Taille := SizeOf(LigneXms)*24;
    if Taille and 1=1 then inc(Taille);
    SrcHdl := EcranXmsHandle;
    SrcOfs := Y*SizeOf(LigneXms);
    DstHdl := 0;
    DstOfs := Ptr2Long(Tampon.Src);
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('affichage de l''cran XMS');

  vram := OfsTamponDessineEcran;
  for iy := 0 to 23 do begin
    CoulF := (iy and 1) shl 4;

    { Code machine }
    CodeMachI := Tampon.Src^[iy*SizeOf(LigneXms)]; { Si =0 -> fin du fichier }
    if NbrCodeMachMax<CodeMachI then CodeMachI := 0;

    if CodeMachI<>0 then for ix := 0 to CodeMachI-1 do begin
      TmpTxt := Hex8z (Tampon.Src^[iy*SizeOf(LigneXms) +OfsLigneXmsMach +ix]);
      Tampon.Src^[vram] := ord(TmpTxt[1]);  inc (vram);
      Tampon.Src^[vram] := CoulMach +CoulF; inc (vram);
      Tampon.Src^[vram] := ord(TmpTxt[2]);  inc (vram);
      Tampon.Src^[vram] := CoulMach +CoulF; inc (vram);
    end;
    for ix := CodeMachI*2 to NbrCodeMachMax*2-1 do begin
      Tampon.Src^[vram] := ord(' ');        inc (vram);
      Tampon.Src^[vram] := CoulMach +CoulF; inc (vram);
    end;

    { Code assembleur }
    Tampon.Src^[vram] := Ord('');        inc (vram);
    Tampon.Src^[vram] := CoulComm +CoulF; inc (vram);
    for ix := 0 to NbrChAsm-1 do begin
      Tampon.Src^[vram] := Tampon.Src^[iy*SizeOf(LigneXms) +OfsLigneXmsTxt +ix*2];                      inc (vram);
      Tampon.Src^[vram] := Tampon.Src^[iy*SizeOf(LigneXms) +OfsLigneXmsTxt +ix*2 +1] +(iy and 1) shl 4; inc (vram);
    end;

    { Position dans le fichier }
    Tampon.Src^[vram] := Ord('');        inc (vram);
    Tampon.Src^[vram] := CoulComm +CoulF; inc (vram);

    if CodeMachI<>0 then begin
      move (Tampon.Src^[iy*SizeOf(LigneXms) +OfsLigneXmsPosF],index,4);
      Str (index:10,TmpTxt);
    end else TmpTxt := '          '; { fin du fichier }

    for ix := 1 to length(TmpTxt) do begin
      Tampon.Src^[vram] := ord(TmpTxt[ix]); inc (vram);
      Tampon.Src^[vram] := CoulPos +CoulF;  inc (vram);
    end;
  end;
  AttendEcran;
  move (Tampon.Src^[OfsTamponDessineEcran],EcrnTxt,160*24);
end;

{}
{                           CHARGEMENT DE L'UNITE                          }
{}

Begin
  EcranX := 0;
  EcranY := 0;
end.