(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
    Utilitaire qui traduit n'importe quel fichier excutable tournant sous  
 DOS: (.exe) et (.com) en code assembleur. Il reconnait la plupard des ins- 
 tructions, dont celles du co-processeur artimtique et du 8086 jusqu'au    
 386 (mme un peu de 486 et de mode protg, mais pas le MMX).              
                                                                            
****************************************************************************
******** Pour plus informations consultez le fichier 'DesAsm.txt' **********
****************************************************************************
*)

{$M 8192,0,65535}

{$A+,B+,D-,G+,I-,L-,N+,Q-,R-,S-,V-,X+ }

{$DEFINE AvecDebut: Va au point d'entre du code }
{$DEFINE SauvePos: Ecrit la position du code actuel dans le fichier '.asm' }

uses
  { !!! Attention, EcranTxt doit tre plac avant DasmXms car les deux  !!! }
  EcranTxt,   { Pour l'cran texte (affichage de texte en couleur) }
  { !!! units utilisent les mmes noms pour des procdures diffrentes !!! }
  Clavier,    { Pour le clavier (LitTouche) }
  Convert,    { Pour l'affichage en hxadcimal }
  DasmXms,    { Pour l'cran virtuel (XMS) }
  DAsmFich,   { Pour la lecture dans le fichier xecutable }
  DasmReg,    { Pour les registres, segments, pointeurs, ... }
  OuvrFich,   { Pour ouvrir un fichier avec la gestion d'erreur (OuvreFich) }
  OptVideo,   { Pour les fonctions vidos spciales }
  Xms;        { Pour la mmoire tendue (XMS) }

const
  Version = '1.1.2';
  Email = 'haypo@ifrance.com';
  PageWeb = 'http://www.multimania.com/haypo/';

  Aide: array[1..23] of record X: shortint; Coul: byte; txt: string[76] end = (
(X: 0;Coul: 0;Txt:''),
(X:-1;Coul:14;Txt:'Informations'),
(X:-1;Coul:14;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 4;Coul:15;Txt:'L''utilitaire ''DesAsm'' est un logiciel de Haypo ('+Email+') qui'),
(X: 1;Coul:15;Txt:'traduit le code machine en assembleur. Il supporte les fichiers excutables'),
(X: 1;Coul:15;Txt:'tournant sous DOS : (.exe) et (.com). Il reconnait la plupard des instruc-'),
(X: 1;Coul:15;Txt:'tions dont celles du co-processeur artimtique et du 8086 jusqu''au 80386'),
(X: 1;Coul:15;Txt:'(mme un peu de 80486 et de mode protg, mais pas le MMX).'),
(X: 0;Coul: 0;Txt:''),
(X:-1;Coul:14;Txt:'Touches utilises'),
(X:-1;Coul:14;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'Haut/Bas : Se dplacer dans le code source'),
(X: 1;Coul:15;Txt:'Dbut/Fin : Se dplacer au dbut/ la fin du code'),
(X: 1;Coul:15;Txt:'Page haut/page bas : Se dplacer page par page vers le haut/vers le bas'),
(X: 1;Coul:15;Txt:'F1 : Affiche l''aide que vous voyez actuellement'),
(X: 1;Coul:15;Txt:'F2 : Explication de l''affichage de DesAsm'),
(X: 0;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'Echape : Quitte  DesAsm '+Version+' '),
(X: 0;Coul: 0;Txt:''),
(X:-1;Coul: 7;Txt:'- Enfoncez une touche pour revenir -'),
(X: 0;Coul: 0;Txt:''));

  TxtInconnu = ' ; Fonction inconnue!';

const
  { Position }
  CodeAsmX = 30;       { X du code assembleur }
  PosFichX  = 69;      { X de la position dans le fichier }
  ExplY = 11;          { Y des explications }
  ExplLarg = 25;       { Largeur des explications }

  { Couleurs }
  CoulAide = 15+3*16;
  CoulAvance = 10+0*16;

var
  { Fichier }
  Dest : Text;
  NomFich,NomFichDest,NomFichComplet,Chemin: string;
  FichExe,SourceExist: Boolean;
  PosMaxFich: LongInt;
  CopieXmsPosF: StructCopieXms;

  { Clavier }
  key: char;

  { Dsassemblage }
  Fonction,bits,bits2: Byte;
  Wait,PushCS,FinTrouvee,DonneeOn: boolean;
  EcranYmax: LongInt;

  { Avance }
  AvancPourc,Avance,         { Avancement dans le fichier }
  AvancX,AvancY,             { Position de la barre d'avancement }
  AvancLarg: byte;           { Largeur de cette barre }

  PosChr: byte;

  ix: byte;

procedure Fin; forward;

procedure AfficheInfoEXE; begin
  EffaceEcranTxt;
  with EnteteEXE do begin
    { Le titre }
    EcranTxt.CoulTxt := 15+7*16;
    EcriTh (80,'');
    EcriTx (-1,0,' Info sur le fichier EXE ');
    EcriTx (-1,1,'ͼ');

    EcranTxt.CoulTxt :=  7+0*16;
    EcranTxt.PosXY (0,5);
    { Nom }
    EcriTcr ('[ Informations sur le fichier ]',11+3*16);
    EcriT ('Il se nomme '''); EcriTc (NomFichComplet,14);
    EcriT (''' et est dans le rpertoire ''');
    if Chemin='' then EcriTc ('(actuel)',14) else EcriTc (Chemin,14); EcriTr ('''');
    EcriT ('Sa taille est de '); str(FileSize(f),txt); EcriTc (txt,14);
    str (NbrPage,txt); EcriTc (' octets (='+txt+' pages dont ',7);
    str (OctetRestant,txt); EcriTr (txt+' octet(s) dans la dernire)');
    SauteLigne;

    { Position du code }
    EcriTcr ('[ Position du code ]',11+3*16);
    EcriT ('Le programme commence  la position = ');

    str (LongInt(OfstCode shl 4),txt); EcriTc (txt,14);
    EcriT (' (rellement ');
    Str(PosDebutCode,txt); EcriTc (txt,14); EcriTr (')');
    SauteLigne;

    { Mmoire }
    EcriTcr ('[ Mmoire ]',11+3*16);
    EcriT ('Pile demande = ');
    Str(MemRecquise,txt); EcriTc (txt,14);
    EcriTr (' octets');

    EcriT ('Mmoire peut-tre recquise = ');
    if MemPtetreRequise<>0 then begin
      str(MemPtetreRequise,txt);
      EcriTcr (txt,14);
    end else EcriTcr ('maximum disponnible',14);

    { ??? }
    EcriTcr ('[ ??? ]',11+3*16);
    EcriT ('Numro du segment de recouvrement = ');
    str(NumeroSegment,txt);
    EcriTcr (txt,14);

    EcriT ('Nombre d''entre(s) dans la table de translation = ');
    str(NbrEntreeTable,txt);
    EcriTcr (txt,14);

    EcriT ('Dplacement du dbut de cette table vers le code = ');
    str(Ptr2Long(PtrDebutPile),txt);
    EcriTcr (txt,14);
    SauteLigne;

    { Dsassemblage en cours ... }
    EcriTcr ('[ Dsassemblage en cours ]',11+3*16);
  end;
end;

procedure AfficheInfoCOM; begin
  EffaceEcranTxt;
  with EnteteEXE do begin
    { Le titre }
    EcranTxt.CoulTxt := 15+7*16;
    EcriTh (80,'');
    EcriTx (-1,0,' Info sur le fichier COM ');
    EcriTx (-1,1,'ͼ');
    EcranTxt.CoulTxt :=  7+0*16;
    EcranTxt.PosXY (0,5);

    { Nom }
    EcriTcr ('[ Informations sur le fichier ]',11+3*16);
    EcriT ('Il se nomme '''); EcriTc (NomFichComplet,14);
    EcriT (''' et est dans le rpertoire ''');
    if Chemin='' then EcriTc ('(actuel)',14) else EcriTc (Chemin,14); EcriTr ('''');
    EcriT ('Sa taille est de '); str(FileSize(f),txt); EcriTc (txt,14); EcriTr (' octets');
    SauteLigne;

    { Position du code }
    EcriTcr ('[ Position du code ]',11+3*16);
    EcriT ('Le programme commence  la position = ');
    str (0,txt); EcriTcr (txt,14);
    SauteLigne;

    { Dsassemblage en cours ... }
    EcriTcr ('[ Dsassemblage en cours ]',11+3*16);
  end;
end;

procedure TestPrefix; begin
  { Utilisation de registres tendus ? (EAX,ECX,EDX,...) }
  if TmpO=$66 then begin
    Reg386 := OUI;
    LitO;
  end else Reg386 := NON;

  { Utilisation de segment particuliers ? (CS,pas ds,ES,FS,GS) }
  Case TmpO of
  $26: MovSeg := 'ES';
  $2E: MovSeg := 'CS';
  $36: MovSeg := 'SS';
  $3E: MovSeg := 'DS';
  $64: MovSeg := 'FS';
  $65: MovSeg := 'GS';
  else MovSeg := 'ds';
  end;

  if MovSeg<>'ds' then LitO;

  { Utilisation d'offsets tendus ? (EDI,ESI,ESP,...) }
  if TmpO=$67 then begin
    Ofs386 := OUI;
    LitO;
  end else Ofs386 := NON;

  { C'est le dernier octet, il ne peut pas tre suivit, on se casse }
  if PosMaxFich<=PosFich+TamponFich.Pos then exit;

  { WAIT ou une fonction de la FPU }
  Wait := NON;
  if TmpO=$9B then with TamponFich do begin
    { Sauve le tampon et la position du fichier }
    move (TamponFich,Tampon.Src^[OfsTamponLibre],SizeOf(TamponFich)); TmpL := FilePos(F);

    { Sauve le nombre de code machine et TmpO }
    X := CodeMachI; TmpM := TmpO;

    { Lit le prochain octet }
    LitO;

    { L'octet est compris entre D8h et DFh (fonctions de la FPU) ? }
    if (TmpO<$D8) or ($DF<TmpO) then begin
    { Non : Remet le tampon fichier dans son tat prcdent }

      { Remet le nombre de code machine et TmpO }
      CodeMachI := X; TmpO := TmpM;

      { Remet le tampon et la position du fichier }
      move (Tampon.Src^[OfsTamponLibre],TamponFich,SizeOf(TamponFich)); Seek (F, TmpL);
    end else Wait := OUI;
  end;

  { PUSH CS ou 'near ptr' }
  PushCS := NON;
  if TmpO=$0E then with TamponFich do begin
    { Sauve le tampon et la position du fichier }
    move (TamponFich,Tampon.Src^[OfsTamponLibre],SizeOf(TamponFich)); TmpL := FilePos(F);

    { Sauve le nombre de code machine et TmpO }
    X := CodeMachI; TmpM := TmpO;

    { Lit le prochain octet }
    LitO;

    { L'octet est compris entre D8h et DFh (fonctions du FPU) ? }
    if TmpO<>$E8 then begin
      PushCS := NON;

      { Remet le nombre de code machine et TmpO }
      CodeMachI :=  X; TmpO := TmpM;

      { Remet le tampon et la position du fichier }
      move (Tampon.Src^[OfsTamponLibre],TamponFich,SizeOf(TamponFich)); Seek (F, TmpL);
    end else PushCS := OUI;
  end;
end;

procedure FoncSHL (NBits, Decal: byte); begin
  LitO;
  Case TmpO shr 3 and 7 of
  0: EcriM ('ROL');
  1: EcriM ('ROR');
  2: EcriM ('RCL');
  3: EcriM ('RCR');
  4: EcriM ('SHL');
  5: EcriM ('SHR');
  6: begin
    CoulTexte (CoulInco);
    EcriM ('FoncSHL inconnu = 6 (SAL?)');
  end;
  7: EcriM ('SAR');
  end; EcriM (' ');

  OfsVar (NBits);
  Virgule;

  Case Decal of
  0: begin CoulTexte (CoulReg); EcriM ('CL') end;
  1: begin CoulTexte (CoulImm); EcriM ('1')  end;
  8: Imm (8);
  end;
end;

procedure DesAsm0F; begin
  LitO;
  Case TmpO of
  { LLDT }
  $00: begin LitO;
    Case TmpO shr 3 and 7 of
    0: EcriM ('SLDT ');
    1: EcriM ('STR ');
    2: EcriM ('LLDT ');
    3: EcriM ('LTR ');
    4: EcriM ('VERR ');
    5: EcriM ('VERW ');
    else begin
      CoulTexte (CoulInco);
      EcriM ('Fonction 0Fh/00h/'+Hex8(TmpO shr 3 and 7)+' inconnue ')
    end end;

    OfsVar (16);
  end;

  $01: begin LitO;
    Case TmpO shr 3 and 7 of
    0: EcriM ('SGDT');
    1: EcriM ('SIDT');
    2: EcriM ('LGDT');
    3: EcriM ('LIDT');
    4: EcriM ('SMSW');
    5: begin CoulTexte (CoulInco); EcriM ('Fonction 0Fh/01h/05h inconnue ') end;
    6: EcriM ('LMSW');
    7: EcriM ('INVLPG');
    end; EcriM (' '); OfsVar (32)
  end;

  { LSL }
  $03: begin EcriM ('LSL '); RegVar (16,16) end;

  { CLTS }
  $06: EcriM ('CLTS');

  { INVD }
  $08: EcriM ('INVD');

  { WBINVD }
  $09: EcriM ('WBINVD');

  { MOV reg(32),TRx }
  $24: begin
    EcriM ('MOV '); LitO;
    Reg (32,rBas);
    Virgule;
    RegTest;
  end;

  { MOV TRx,reg(32) }
  $26: begin
    EcriM ('MOV '); LitO;
    RegTest;
    Virgule;
    Reg (32,rBas);
  end;

  { Jxx near ptr $+imm(16) }
  $80..$8F: begin EcriM ('J'); NomCas; JmpPtrD (16); ImmJmp (16,+4) end;

  { SETA }
  $90..$9F: begin EcriM ('SET'); NomCas; LitO; OfsVar (8) end;

  { PUSH/POP  FS }
  $A0: begin EcriM ('PUSH '); CoulTexte (CoulSegm); EcriM ('FS') end;
  $A1: begin EcriM ('POP ' ); CoulTexte (CoulSegm); EcriM ('FS') end;

  { CPUID }
  $A2: EcriM ('CPUID');

  { BT reg,reg (16) }
  $A3: begin EcriM ('BT ' ); VarReg (16,16) end;

  { SHLD reg(16),reg(16),imm(8) }
  $A4: begin EcriM ('SHLD ');  VarReg (16,16); EcriM (','); Imm (8) end;

  { XCHG AX , reg(16) }
  $A7: begin EcriM ('CMPXCHG '); VarReg (16,16) end;

  { PUSH/POP  GS }
  $A8: begin EcriM ('PUSH '); CoulTexte (CoulSegm); EcriM ('GS') end;
  $A9: begin EcriM ('POP ' ); CoulTexte (CoulSegm); EcriM ('GS') end;

  { BTS reg,reg (16) }
  $AB: begin EcriM ('BTS ' ); VarReg (16,16) end;

  { SHRD reg(16),reg(16),imm(8) }
  $AC: begin EcriM ('SHRD ');  VarReg (16,16); Virgule; Imm (8) end;

  { IMUL reg,reg(16) }
  $AF: begin EcriM ('IMUL '); RegVar (16,16) end;

  { LSS }
  $B2: begin EcriM ('LSS '); CoulTexte (CoulReg); LitO; Reg (16,rHAUT); Virgule; SegOfst (16) end;

  { LFS/LGS reg(16),mem(32) }
  $B4: begin EcriM ('LFS '); RegVar (32,32) end;
  $B5: begin EcriM ('LGS '); RegVar (32,32) end;

  { MOVZX reg(16/32),var(8/16) }
  $B6: begin EcriM ('MOVZX '); RegVarImpose (16,8) end;
  $B7: begin EcriM ('MOVZX '); RegVarImpose (32,16) end;

  { BT/BTC [selon bit(#4) ]/BTS [selon bit(#5)] reg,imm(8) }
  $BA: begin LitO; EcriM ('BT');

    Case TmpO shr 3 and 7 of
    4: InLine($90);
    5: EcriM ('S');
    7: EcriM ('C');
    else begin
      CoulTexte (CoulInco);
      str (TmpO shr 3 and 7,txt);
      EcriM ('db 0Fh,0BAh,'+Hex8(TmpO)+TxtInconnu+' >'+txt)
    end end; EcriM (' ');

    RegImm (16,8);
  end;

  { BTC reg,reg (16) }
  $BB: begin EcriM ('BTC ' ); VarReg (16,16) end;

  { BSF/BSR reg,reg/var (16) }
  $BC: begin EcriM ('BSF '); RegVar (16,16) end;
  $BD: begin EcriM ('BSR '); RegVar (16,16) end;

  { MOVSX reg(16/32),var(8/16) }
  $BE: begin EcriM ('MOVSX '); RegVarImpose (16,8)  end;
  $BF: begin EcriM ('MOVSX '); RegVarImpose (32,16) end;

  { XADD reg/var,reg (16 ou 32) }
  $C0..$C7: begin EcriM ('XADD '); VarReg (16,16) end;

  { BSWAP reg (16/32) }
  $C8..$CF: begin EcriM ('BSWAP '); Reg (16,rBAS) end;

  else begin
    CoulTexte (CoulInco);
    EcriM ('db 0Fh,'+Hex8(TmpO)+TxtInconnu)
  end end;
end;

function FichExist (NomFich: String) : boolean; var f: file; begin
  {$I-} Assign (F,NomFich); FileMode := 0; Reset (F,1); {$I+}

  erreur := IOResult;

  FichExist := (erreur=0);

  if erreur=0 then Close(F);
end;

procedure SauveAsm; var iy: LongInt; begin
  if EcranYmax=0 then exit;

  InitModeTxt;
  EcriTc ('Voulez-vous sauver le code source dans un fichier .ASM ? (O/N) ',15);
  if UpCase(LitTouche)<>'O' then exit;
  EffaceLigneTxt;

  InitModeTxt; CurseurOff; EcranTxt.CoulTxt :=  7+0*16;

  txt := '.asm';
  SourceExist := FichExist(NomFichDest+txt);
  if SourceExist then txt := '.as2'; NomFichDest := NomFichDest+txt;

  { Affiche un texte explicatif }
  EcriT   ('Sauvegarde de code assembleur dans ');
  EcriTcr (NomFichDest,10);

  { Initialise la barre d'avancement }
  txt := 'Avancement: '; AvancPourc := $FF;
  EcriT (txt); EcriTc ('000',1); AvancX := EcranX; AvancY := EcranY; EcriTr ('%');
  AvancLarg := 80; EcriThc (AvancLarg,'',7 +CoulAvance and $F0);

  { Cre le fichier destination o sera crit la source en assembleur }
  Assign (Dest,NomFichDest); Rewrite (Dest);

  { Ecrit l'en-tte }
  WriteLn (Dest,';  ');
  WriteLn (Dest,';  Code ASM gnr pas DesASM '+Version);
  WriteLn (Dest,';  Un programme de Haypo ('+Email+')');
  WriteLn (Dest,';  ');

  Writeln (Dest);
  if FichExe then begin
    WriteLn (Dest,'DOSSEG');
    WriteLn (Dest,'.MODEL MEDIUM');
    WriteLn (Dest,'.STACK ',Hex32(EnTeteEXE.MemRecquise));
    WriteLn (Dest,'JUMPS     ; Permet de faire des bonds de plus de 127 octets (JMP,JNZ,...)');
    WriteLn (Dest,'          ; Si vous n''utilisez pas TASM effacez cette ligne');
    WriteLn (Dest);
    WriteLn (Dest,'.CODE');
  end else begin
    WriteLn (Dest,'.MODEL TINY');
    WriteLn (Dest,'.CODE');
    WriteLn (Dest,'  ORG 100h');
    WriteLn (Dest,'LeCode: ');
  end;
  WriteLn (Dest,'.386');
  WriteLn (Dest,'.387');
  WriteLn (Dest,'; Dbut du code ');

  with CopieXms do begin
    Taille := NbrChAsm*2;
    SrcHdl := EcranXmsHandle;
    SrcOfs := OfsLigneXmsTxt;
    DstHdl := 0;
    DstOfs := Ptr2Long(Addr(txt[1]));
  end;

  with CopieXmsPosF do begin
    Taille := 4;
    SrcHdl := EcranXmsHandle;
    SrcOfs := OfsLigneXmsPosF;
    DstHdl := 0;
    DstOfs := Ptr2Long(Addr(TmpL));
  end;

  {$IFDEF SauvePos}
    X := NbrChAsm;
    txt[0] := chr(X);
  {$ELSE}
    X := NbrChAsm-1;
  {$ENDIF}

  Avance := $FF;
  for iy := 0 to EcranYmax-1 do begin
    { Copie une ligne de l'cran XMS dans la variable texte }
    CopieMemXms (CopieXms);
    TestErreurXms ('sauvegarde du code ASM (txt)');

    {$IFDEF SauvePos}
    { Copie la position du fichier }
    CopieMemXms (CopieXmsPosF);
    TestErreurXms ('sauvegarde du code ASM (posF)');
    {$ENDIF SauvePos}

    { Convertit la ligne de l'cran XMS en texte }
    for i := 1 to X do txt[i] := txt[i*2 -1];

    txt[0] := chr(X);
    {$IFDEF SauvePos}
    Str (TmpL,TmpTxt);
    txt := txt+'; '+TmpTxt;
    {$ELSE}
    While (txt[length(txt)]=#0) and (0<length(txt)) do delete(txt,length(txt),1);
    {$ENDIF}

    { Sauve le texte dans le fichier destination }
    WriteLn (Dest,txt);

    { Dessine la barre d'avancement }
    TmpO := iy*100 div EcranYmax;
    if TmpO<>AvancPourc then begin
      AvancPourc := TmpO;
      Avance := iy*AvancLarg div EcranYmax;
      str (AvancPourc,txt); EcriTxc (AvancX-length(txt),AvancY,txt,14);
      EcriTxhc (0,AvancY+1,Avance,'',CoulAvance);
    end;

    { Passe  la ligne suivante }
    inc (CopieXms.SrcOfs,SizeOf(LigneXms));
    inc (CopieXmsPosF.SrcOfs,SizeOf(LigneXms));
  end;

  WriteLn (Dest,'; Fin du code ');
  Write (Dest,'END');
  if not FichExe then Write (Dest,' LeCode');
  Close (Dest);

  EcriTxhc (0,AvancY,80,  ' ', 7+0*16);
  EcriTxhc (0,AvancY+1,80,' ', 7+0*16);
  PosXY (0,AvancY+1);
end;

procedure CreeDonnee; begin
{  SauveASM;}

  if SourceExist then txt := 'da2' else  txt := 'dat';

  WriteLn (Dest,'; Fin du code ');
  WriteLn (Dest);
  WriteLn (Dest,'INCLUDE '+NomFich+'.'+txt);
  WriteLn (Dest);
  Write (Dest,'END'); if not FichExe then Write (Dest,' LeCode'); Writeln;
  Close (Dest);

  FileMode := 1;
  Assign (Dest,Chemin+NomFich+'.'+txt); Rewrite (Dest);
  WriteLn (Dest,'; Donne du programme ASM '+NomFich+' gnr pas DesASM '+Version);
  WriteLn (Dest,'; Un programme de Stinner Victor ('+Email+')');
  Writeln (Dest);

  if (PosFich +TamponFich.Pos) and 15<>0 then
    Write (Dest,'M',Hex16z(PosFich +TamponFich.Pos),' DB ');

  FinTrouvee := FALSE; i := 1;
  repeat
    if i=0 then begin
      Writeln (Dest);
      with TamponFich do Write (Dest,'M',Hex16z(PosFich +Pos),' DB ',Hex8(Src[Pos]));
    end else with TamponFich do Write (Dest,Hex8(Src[Pos]));

    inc (TamponFich.Pos);
    if i<>15 then begin
      with TamponFich do if ((PosMax<>Pos) or ((PosMax=Pos) and ((FileSize(f) - FilePos (f))<>0)))
      then Write (Dest,',');

      inc(i);
    end else i := 0;

    with TamponFich do if PosMax<=Pos then begin
      if (FileSize(f) < FilePos (f)+TailleTamponFich) then begin
        PosMax := FileSize(f) - FilePos (f);
        FinTrouvee := (PosMaxFich<=PosFich+Pos);
        Write (PosMax);
        BlockRead (f,TamponFich,PosMax);
      end else begin
        PosMax := TailleTamponFich;
        BlockRead (f,Tampon,TailleTamponFich);
      end;

      with TamponFich do begin
        Pos := 0;
        PosFich := FilePos(f)-PosMax;
      end;
    end;
  until FinTrouvee;
  Writeln (Dest);

  Close (Dest); DonneeOn := TRUE;
end;

procedure AfficheExplication; var SauveEcranYaide: byte; begin
  { Sauve les cran XMS, texte, et sauve EcranY }
(*  SauveEcranXms (0);  *****************************************)
  SauveEcranYaide := EcranY;
  move (EcrnTxt,SavEcrnTxt2,4000);

  { Copie l'cran XMS de la position actuelle vers la position 0 }
  with CopieXms do begin
    Taille := 4000;
    SrcHdl := EcranXmsHandle;
    SrcOfs := EcranY shl 7 +EcranY shl 5;
    DstHdl := EcranXmsHandle;
    DstOfs := 0;
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('affichage de l''aide');

  { Ecrit l'aide  la position 0 de l'cran XMS }
  PosXY (0,0);

  { Aide suprieure explicant les diffrantes parties de l'cran }
  EcranTxt.CoulTxt := CoulAide;
  EcriTh (80,' ');
  txt := 'Code machine'; EcriTx ((CodeAsmX-length(txt)) shr 1,0,txt);
  EcriTx (CodeAsmX,0,''); txt := 'Code assembleur';
  EcriTx (CodeAsmX+(PosFichX-CodeAsmX-length(txt)) shr 1,0,txt);
  txt := ' Position'; EcriTx (PosFichX,0,txt);

  EcriTxh (0,1,80,ChLigneH);
  EcriTx (CodeAsmX,1,'');
  EcriTx (PosFichX,1,'');

  { Lignes pour l'aide du bas sur les couleurs }
  EcriTxh (0,ExplY,80,ChLigneH);
  for i := 1 to 22-ExplY do begin
    EcriTxh (0,ExplY+i,80,' ');
    EcriTx (0+ExplLarg,ExplY+i,ChLigneV);
    EcriTx (0+ExplLarg+6,ExplY+i,ChLigneV);
  end;
  EcriTxh (0,ExplY+2,80,ChLigneH);
  EcriTxh (0,23,80,ChLigneH);
  EcriTx (ExplLarg,ExplY,'');
  EcriTx (ExplLarg+6,ExplY,'');
  EcriTx (ExplLarg,23,'');
  EcriTx (ExplLarg+6,23,'');
  EcriTx (ExplLarg,ExplY+2,'');
  EcriTx (ExplLarg+6,ExplY+2,'');

  { Etablit la liaison avec l'aide du haut }
  EcriTxc (CodeAsmX,ExplY,'',CoulAide);
  EcriTxc (PosFichX,ExplY,'',CoulAide);

  { Prsentation des couleurs }
  txt := 'Couleurs des';
  EcriTxc ((ExplLarg-length(txt)) shr 1,ExplY+1,txt,14+CoulAide and $F0);
  EcriTxc (ExplLarg+1,ExplY+1,'Index',14+CoulAide and $F0);
  EcriTxc (ExplLarg+8,ExplY+1,'Exemples',14+CoulAide and $F0);

  { Offset }
  str (CoulOfst:5,TmpTxt);
  EcriTxc (0,ExplY+3,'Offsets',CoulAide);
  EcriTxc (ExplLarg+1,ExplY+3,TmpTxt,CoulOfst);
  EcriTxc (ExplLarg+7,ExplY+3,'ds:[__+__]',CoulAide);
  EcriTxc (ExplLarg+11,ExplY+3,'BX+SI',CoulOfst);

  { Commentaires }
  str (CoulComm:5,TmpTxt);
  EcriTxc (0,ExplY+4,'Commentaires',CoulAide);
  EcriTxc (ExplLarg+1,ExplY+4,TmpTxt,CoulComm);
  EcriTxc (ExplLarg+7,ExplY+4,'byte ptr, near ptr',CoulComm);

  { Segment }
  str (CoulSegm:5,TmpTxt);
  EcriTxc (0,ExplY+5,'Segments',CoulAide);
  EcriTxc (ExplLarg+1,ExplY+5,TmpTxt,CoulSegm);
  EcriTxc (ExplLarg+7,ExplY+5,'ds:[__+__]',CoulSegm);
  EcriTxc (ExplLarg+11,ExplY+5,'BX+SI',CoulAide);

  { Registe }
  str (CoulReg:5,TmpTxt);
  EcriTxc (0,ExplY+6,'Registres',CoulAide);
  EcriTxc (ExplLarg+1,ExplY+6,TmpTxt,CoulReg);
  EcriTxc (ExplLarg+7,ExplY+6,'AX,DX,EBX',CoulReg);

  { Immdiate }
  str (CoulImm:5,TmpTxt);
  EcriTxc (0,ExplY+7,'Immdiates',CoulAide);
  EcriTxc (ExplLarg+1,ExplY+7,TmpTxt,CoulImm);
  EcriTxc (ExplLarg+7,ExplY+7,'120,-51224,10h,0FFFFh',CoulImm);

  { Inconnu }
  str (CoulInco:5,TmpTxt);
  EcriTxc (0,ExplY+8,'Fonctions inconnues',CoulAide);
  EcriTxc (ExplLarg+1,ExplY+8,TmpTxt,CoulInco);
  EcriTxc (ExplLarg+7,ExplY+8,'db ??h,??h'+TxtInconnu,CoulInco);

  { Code machine }
  str (CoulMach:5,TmpTxt);
  EcriTxc (0,ExplY+9,'(du) code machine',CoulAide);
  EcriTxc (ExplLarg+1,ExplY+9,TmpTxt,CoulMach);
  EcriTxc (ExplLarg+7,ExplY+9,'B2C057F68E0A',CoulMach);

  { Position dans le fichier }
  str (CoulPos:5,TmpTxt);
  EcriTxc (0,ExplY+10,'Position dans le fichier',CoulAide);
  EcriTxc (ExplLarg+1,ExplY+10,TmpTxt,CoulPos);
  EcriTxc (ExplLarg+7,ExplY+10,'B2C057F68E0A',CoulPos);

  str (CoulFonc:5,TmpTxt);
  EcriTxc (0,ExplY+11,'Fonctions',CoulAide);
  EcriTxc (ExplLarg+1,ExplY+11,TmpTxt,CoulFonc);
  EcriTxc (ExplLarg+7,ExplY+11,'MOV, ADD, LES, fnop',CoulFonc);

  { Ecrit un texte qui demande  enfoncer une touche }
  EcranTxt.CoulTxt := 14+4*16;
  EcriTxh (0,24,80,' ');
  EcriTx (-1,24,'Enfoncez une touche pour revenir');

  LitTouche;

  { Remet les cran XMS, texte, et remet EcranY }
  EcranY := SauveEcranYaide;
(*  RemetEcranXms (0); ************************************************)
  move (SavEcrnTxt2,EcrnTxt,4000);
end;

procedure AfficheAide; var min,max,iy: byte; vram: word; begin
  VideTamponClavier;

  { Ecrit l'aide dans le Double-Buffer (page 2 de la mmoire vido) }
  CoulTxt :=  9+1*16; vram := 0;
  for i := 0 to 1999 do begin
    SavEcrnTxt[vram] := Ord(' '); inc (vram);
    SavEcrnTxt[vram] := CoulTxt; inc (vram);
  end;

  Vram := 0;
  SavEcrnTxt[0] := ord(ChDCoinHG);
  for ix := 1 to 78 do SavEcrnTxt[ix shl 1] := Ord(ChDLigneH);
  SavEcrnTxt[158] := ord(ChDCoinHD);
  vram := 24*160;
  SavEcrnTxt[vram] := ord(ChDCoinBG);
  for ix := 1 to 78 do SavEcrnTxt[vram +ix shl 1] := Ord(ChDLigneH);
  SavEcrnTxt[vram+158] := ord(ChDCoinBD);

  vram := 160;
  for iy := 1 to 23 do with Aide[iy] do begin
    vram := iy shl 7 + iy shl 5;
    SavEcrnTxt[vram] := ord(ChDLigneV); inc (vram,2);

    if X<0 then begin
      min := (80-length(txt)) shr 1;
      max := min +length(txt);
    end else if X=0 then begin
      min := 0;
      max := 0;
    end else begin
      min := X;
      max := min +length(txt);
    end;

    inc (vram,min*2);
    for ix := min+1 to max do begin
      SavEcrnTxt[vram] := ord(Txt[ix-min]);      inc (vram);
      SavEcrnTxt[vram] := Coul +CoulTxt and $F0; inc (vram);
    end;
    inc (vram,(78-max)*2);

    SavEcrnTxt[vram] := ord(ChDLigneV);
  end;

  { Scrolle l'cran vers le double-buffer (page 0 -> 1) }
  vram := 0;
  for i := 0 to 25 do begin
    AttendEcran;
    ChangeDebutAffich (vram);
    inc (vram,80);
  end;

  LitTouche;

  { Scrolle le double-buffer vers l'cran (page 1 -> 0) }
  for iy := 0 to 25 do begin
    dec (vram,80);
    AttendEcran;
    ChangeDebutAffich (vram);
  end;
end;

procedure DemandeFin; begin
  Exit;

  AfficheEcranXms (EcranY);
  move (EcrnTxt,SavEcrnTxt,SizeOf(EcranTxt80x25));

  EcriTxc (0,(EcranY+1) mod 24,'[ F1: Aide         -> Est-ce la fin du fichier ? (O/N) <-      Echape: Quitter ]',14+4*16);

  FinTrouvee := FALSE;
  while (not FinTrouvee) do begin
    key := #0;
    while (key<>'O') and (key<>'N') and (key<>_ECHAPE) and (key<>_F1) do key := UpCase(LitTouche);

    Case key of
    'O': begin FinTrouvee := TRUE; CreeDonnee; Fin end;
    'N': FinTrouvee := TRUE;
    _ECHAPE: begin FinTrouvee := FALSE; Fin end;
    _F1: begin
      move (SavEcrnTxt,Tampon.Src^,SizeOf(EcranTxt80x25));
      AfficheAide;
      move (Tampon.Src^,SavEcrnTxt,SizeOf(EcranTxt80x25));
    end end;
  end;

  move (SavEcrnTxt,EcrnTxt,SizeOf(EcranTxt80x25));

  FinTrouvee := FALSE;
end;

Procedure DesassembleCode; begin
  { Initialise la barre d'avancement }
  Ecrit ('Avancement: '); EcriTc ('000',1); AvancX := EcranTxt.EcranX; AvancY := EcranTxt.EcranY; EcriTr ('%');
  AvancLarg := 80; EcriThc (AvancLarg,'',7 +CoulAvance and $F0);
  AvancPourc := $FF;

  { Dsassemble le code machine, jusqu' la fin du fichier }
  FinTrouvee := FALSE;
  repeat
    CodeMachI := 0;

    { Lit un octet dans le tampon du fichier }
    LitO;

    { Ecrit la position dans le fichier }
    TmpL := PosFich+TamponFich.Pos-1;
    with CopieXMS do begin
      Taille := 4;
      SrcHdl := 0;
      SrcOfs := Ptr2Long(Addr(TmpL));
      DstHdl := EcranXmsHandle;
      DstOfs := EcranY*SizeOf(LigneXms) +OfsLigneXmsPosF;
    end;
    CopieMemXms (CopieXms);
    TestErreurXms ('criture de la position du fichier');

    { Dessine la barre d'avancement }
    with EnteteEXE do x := LongInt(PosFich+TamponFich.Pos-PosDebutCode)
                          *100 div (PosMaxFich-PosDebutCode);
    if AvancPourc<>x then begin
      AvancPourc := x;
      str (AvancPourc,txt); EcriTxc (AvancX-length(txt),AvancY,txt,14);
      with EnteteEXE do Avance := LongInt(PosFich+TamponFich.Pos-PosDebutCode)
                                 *AvancLarg div (PosMaxFich-PosDebutCode);
      EcriTxhc (0,AvancY+1,Avance,'',CoulAvance);

      { Une touche est presse, et c'est echape, quitte DesAsm }
      if TouchPresse then if LitTouche=_ECHAPE then begin
        EffaceEcranTxt;
        EcriTcr ('Interruption de l''utilisateur !',14+4*16);
        SauteLigne;
        Fin;
      end;
    end;

    { Vrifit que l'octet n'est pas un prfixe (386,segment) }
    TestPrefix;
    Fonction := TmpO;

    CoulTexte(CoulFonc); EcranX := 0;
    Case Fonction of

    { ADD }
    $00: begin EcriM ('ADD ');
      VarReg ( 8, 8);

      { Sauve le tampon et la position du fichier }
      move (TamponFich,Tampon.Src^[OfsTamponLibre],SizeOf(TamponFich)); TmpL := FilePos(F);

      { Sauve le nombre de code machine }
      X := CodeMachI;

      { Lit les quatres prochains octets }
      TmpM := 0;
      LitO; inc (TmpM,TmpO);
      LitO; inc (TmpM,TmpO);
      LitO; inc (TmpM,TmpO);
      LitO; inc (TmpM,TmpO);

      { Leur somme est nulle? Oui -> Demande si c'est la fin du fichier }
      if TmpM=0 then DemandeFin;

      { Remet le nombre de code machine }
      CodeMachI :=  X;

      { Remet le tampon et la position du fichier }
      move (Tampon.Src^[OfsTamponLibre],TamponFich,SizeOf(TamponFich)); Seek (F, TmpL);
    end;

    $01: begin EcriM ('ADD '); VarReg (16,16) end;
    $02: begin EcriM ('ADD '); RegVar ( 8, 8) end;
    $03: begin EcriM ('ADD '); RegVar (16,16) end;
    $04: begin EcriM ('ADD '); Ax( 8); Virgule; Imm (8)  end;
    $05: begin EcriM ('ADD '); Ax(16); Virgule; Imm (16) end;

    { PUSH/POP ES }
    $06: begin EcriM ('PUSH '); CoulTexte(CoulSegm); EcriM ('ES') end;
    $07: begin EcriM ('POP ');  CoulTexte(CoulSegm); EcriM ('ES') end;

    { OR }
    $08: begin EcriM ('OR '); VarReg ( 8, 8) end;
    $09: begin EcriM ('OR '); VarReg (16,16) end;
    $0A: begin EcriM ('OR '); RegVar ( 8, 8) end;
    $0B: begin EcriM ('OR '); RegVar (16,16) end;
    $0C: begin EcriM ('OR '); Ax( 8); Virgule; Imm (8) end;
    $0D: begin EcriM ('OR '); Ax(16); Virgule; Imm (16) end;

    { PUSH CS ("pop cs" est interdit) }
    $0E: begin EcriM ('PUSH '); EcriMc ('CS',CoulSegm) end;

    { Fonction tendue 0Fh (PUSH/POP FS,GS ; Jxx near(xxx) ) }
    $0F: DesAsm0F;

    { ADC }
    $10: begin EcriM ('ADC '); VarReg ( 8, 8) end;
    $11: begin EcriM ('ADC '); VarReg (16,16) end;
    $12: begin EcriM ('ADC '); RegVar ( 8, 8) end;
    $13: begin EcriM ('ADC '); RegVar (16,16) end;
    $14: begin EcriM ('ADC '); Ax( 8); Virgule; Imm (8)  end;
    $15: begin EcriM ('ADC '); Ax(16); Virgule; Imm (16) end;

    { PUSH/POP SS }
    $16: begin EcriM ('PUSH '); CoulTexte (CoulSegm); EcriM ('SS') end;
    $17: begin EcriM ('POP ' ); CoulTexte (CoulSegm); EcriM ('SS') end;

    { SBB }
    $18: begin EcriM ('SBB '); VarReg ( 8, 8) end;
    $19: begin EcriM ('SBB '); VarReg (16,16) end;
    $1A: begin EcriM ('SBB '); RegVar ( 8, 8) end;
    $1B: begin EcriM ('SBB '); RegVar (16,16) end;
    $1C: begin EcriM ('SBB '); Ax( 8); Virgule; Imm (8)  end;
    $1D: begin EcriM ('SBB '); Ax(16); Virgule; Imm (16) end;

    { PUSH/POP DS }
    $1E: begin EcriM ('PUSH '); CoulTexte (CoulSegm); EcriM ('DS') end;
    $1F: begin EcriM ('POP ' ); CoulTexte (CoulSegm); EcriM ('DS') end;

    { AND }
    $20: begin EcriM ('AND '); VarReg ( 8, 8) end;
    $21: begin EcriM ('AND '); VarReg (16,16) end;
    $22: begin EcriM ('AND '); RegVar ( 8, 8) end;
    $23: begin EcriM ('AND '); RegVar (16,16) end;
    $24: begin EcriM ('AND '); Ax( 8); Virgule; Imm (8) end;
    $25: begin EcriM ('AND '); Ax(16); Virgule; Imm (16) end;

    { $26: Utilise le segment ES (Test avec la fonction TestSeg) }

    { DAA }
    $27: EcriM ('DAA');

    { SUB }
    $28: begin EcriM ('SUB '); VarReg ( 8, 8) end;
    $29: begin EcriM ('SUB '); VarReg (16,16) end;
    $2A: begin EcriM ('SUB '); RegVar ( 8, 8) end;
    $2B: begin EcriM ('SUB '); RegVar (16,16) end;
    $2C: begin EcriM ('SUB '); Ax( 8); Virgule; Imm (8)  end;
    $2D: begin EcriM ('SUB '); Ax(16); Virgule; Imm (16) end;

    { $2E: Utilise le segment CS (Test avec la fonction TestSeg) }

    { DAS }
    $2F: EcriM ('DAS');

    { XOR }
    $30: begin EcriM ('XOR '); VarReg ( 8, 8) end;
    $31: begin EcriM ('XOR '); VarReg (16,16) end;
    $32: begin EcriM ('XOR '); RegVar ( 8, 8) end;
    $33: begin EcriM ('XOR '); RegVar (16,16) end;
    $34: begin EcriM ('XOR '); Ax( 8); Virgule; Imm (8) end;
    $35: begin EcriM ('XOR '); Ax(16); Virgule; Imm (16) end;

    { $36: Utilise le segment SS (Test avec la fonction TestSeg) }

    { AAA }
    $37: EcriM ('AAA');

    { CMP }
    $38: begin EcriM ('CMP '); VarReg ( 8, 8) end;
    $39: begin EcriM ('CMP '); VarReg (16,16) end;
    $3A: begin EcriM ('CMP '); RegVar ( 8, 8) end;
    $3B: begin EcriM ('CMP '); RegVar (16,16) end;
    $3C: begin EcriM ('CMP '); Ax( 8); Virgule; Imm (8) end;
    $3D: begin EcriM ('CMP '); Ax(16); Virgule; Imm (16) end;

    { $3E: Utilise le segment DS (Test avec la fonction TestSeg) }

    { AAS }
    $3F: EcriM ('AAS');

    { INC/DEC/PUSH/POP AX,BX,CX,DX,SI,DI }
    $40..$47: begin EcriM ('INC ');  Reg (16,rBAS) end;
    $48..$4F: begin EcriM ('DEC ');  Reg (16,rBAS) end;
    $50..$57: begin EcriM ('PUSH '); Reg (16,rBAS) end;
    $58..$5F: begin EcriM ('POP ');  Reg (16,rBAS) end;

    { PUSH/POP A/AD }
    $60: begin EcriM ('PUSHA'); if Reg386 then EcriM ('D') end;
    $61: begin EcriM ('POPA');  if Reg386 then EcriM ('D') end;

    { BOUND reg(16/32) ,mem(32/64) }
    $62: begin EcriM ('BOUND '); RegVar (16,32) end;

    { ARPL reg,reg (16) }
    $63: begin EcriM ('ARPL '); VarReg (16,16) end;

    { $64: Utilise le segment FS (Test avec la fonction TestSeg) }
    { $65: Utilise le segment GS (Test avec la fonction TestSeg) }
    { $66: Utilise les registres du 386 (Test avec la fonction Test386) }
    { $67: Utilise les offsets   du 386 (Test avec la fonction Test386) }

    { PUSH imm(16) }
    $68: begin EcriM ('PUSH '); if Reg386 then Imm (32) else Imm (16) end;

    { IMUL reg(16/32) , imm(16/32) }
    $69: begin EcriM ('IMUL '); LitO; RegImm (16,16) end;

    { PUSH imm(8) }
    $6A: begin EcriM ('PUSH '); Imm (8) end;

    { IMUL reg/var(16/32) , imm(8) }
    $6B: begin EcriM ('IMUL '); LitO; RegImm (16,8) end;

    { INS/OUTB/W/D }
    $6C: EcriM ('INSB');
    $6D: begin EcriM ('INS'); if Reg386 then EcriM ('D') else EcriM ('W') end;
    $6E: EcriM ('OUTSB');
    $6F: begin EcriM ('OUTS'); if Reg386 then EcriM ('D') else EcriM ('W') end;

    { Jxx }
    $70..$7F: begin Ofs386 := FALSE; EcriM ('J'); NomCas; JmpPtrD (8); ImmJmp (8,+2) end;

    { ADD/SUB/CMP/... reg(8/16) , imm(8/16) }
    $80,$81,$83: begin
      Case TmpO and 3 of
             { registre   - immdiate }
      0: begin bits :=  8; bits2 :=  8 end;
      1: begin bits := 16; bits2 := 16 end;
      3: begin bits := 16; bits2 :=  8 end;
      end;

      LitO;
      Case TmpO shr 3 and 7 of
      0: EcriM ('ADD');
      1: EcriM ('OR');
      2: EcriM ('ADC');
      3: EcriM ('SBB');
      4: EcriM ('AND');
      5: EcriM ('SUB');
      6: EcriM ('XOR');
      7: EcriM ('CMP');
      end; EcriM (' ');

      OfsVar (bits); Virgule; Imm (bits2);
    end;

    { TEST reg , reg/var (8/16) }
    $84: begin EcriM ('TEST '); RegVar ( 8, 8) end;
    $85: begin EcriM ('TEST '); RegVar (16,16) end;

    { XCHG reg , reg/var (8) }
    $86: begin EcriM ('XCHG '); RegVar ( 8, 8) end;
    $87: begin EcriM ('XCHG '); RegVar (16,16) end;

    { MOV reg/var,reg (8/16) }
    $88: begin EcriM ('MOV '); VarReg ( 8, 8) end;
    $89: begin EcriM ('MOV '); VarReg (16,16) end;

    { MOV reg , reg/var (8/16) }
    $8A: begin EcriM ('MOV '); RegVar (8,8)   end;
    $8B: begin EcriM ('MOV '); RegVar (16,16) end;

    { MOV reg (16), seg }
    $8C: begin EcriM ('MOV '); RegSeg end;

    { MOV seg , reg (16)}
    $8E: begin EcriM ('MOV '); SegReg end;

    { LEA reg , val (16) }
    $8D: begin EcriM ('LEA '); RegVar (16,16) end;

    { POP Seg:[Ofst] (16) }
    $8F: begin EcriM ('POP '); LitO; OfsVar(16) end;

    { NOP : Ne fait rien pendant un cycle d'horloge }
    $90: EcriM ('NOP');

    { XCHG AX , reg(16) }
    $91..$97: begin EcriM ('XCHG '); Ax(16); Virgule; Reg (16,rBAS) end;

    { CWB/CWD/CDQ }
    $98: if Reg386 then EcriM ('CWDE') else EcriM ('CBW');
    $99: if Reg386 then EcriM ('CDQ')  else EcriM ('CWD');

    { CALL CS:segm*16+ofst }
    $9A: begin EcriM ('CALL '); Pointeur end;

    { WAIT }
    $9B: EcriM ('WAIT');

    { PUSHF / POPF }
    $9C: begin EcriM ('PUSHF'); if Reg386 then EcriM ('D') end;
    $9D: begin EcriM ('POPF');  if Reg386 then EcriM ('D') end;

    { SAHF / LAHF }
    $9E: EcriM ('SAHF');
    $9F: EcriM ('LAHF');

    { MOV AL , var(8) }
    $A0: begin EcriM ('MOV '); Ax( 8); Virgule; Var_( 8) end;
    $A1: begin EcriM ('MOV '); Ax(16); Virgule; Var_(16) end;

    { MOV var (8/16),AL/AX }
    $A2: begin EcriM ('MOV '); Var_( 8); Virgule; Ax( 8) end;
    $A3: begin EcriM ('MOV '); Var_(16); Virgule; Ax(16) end;

    { MOVSB/W/D (8/16/32) }
    $A4: EcriM ('MOVSB');
    $A5: if Reg386 then EcriM ('MOVSD') else EcriM ('MOVSW');

    { CMPSB/W/D (8/16/32) }
    $A6: EcriM ('CMPSB');
    $A7: if Reg386 then EcriM ('CMPSD') else EcriM ('CMPSW');

    { TEST AL,imm(8) // AX,imm(16)}
    $A8: begin EcriM ('TEST '); TmpO := 0; Reg ( 8,rBAS); EcriM (','); Imm (8)  end;
    $A9: begin EcriM ('TEST '); TmpO := 0; Reg (16,rBAS); EcriM (','); Imm (16) end;

    { STOS(B/W/D) }
    $AA: EcriM ('STOSB');
    $AB: if Reg386 then EcriM ('STOSD') else EcriM ('STOSW');

    { LODS(B/W/D) }
    $AC: EcriM ('LODSB');
    $AD: if Reg386 then EcriM ('LODSD') else EcriM ('LODSW');

    { SCAS(B/W/D) }
    $AE: EcriM ('SCASB');
    $AF: if Reg386 then EcriM ('SCASD') else EcriM ('SCASW');

    { MOV reg,imm (8/16) }
    $B0..$B7: begin EcriM ('MOV '); RegImm ( 8, 8) end;
    $B8..$BF: begin EcriM ('MOV '); RegImm (16,16) end;

    { SHL/RCL/ROL/... reg/var(16),imm(8) }

    { SHL/SHR  reg/var(8/16) ,imm(8) }
    $C0: FoncSHL ( 8,8);
    $C1: FoncSHL (16,8);

    { RETN Imm (16) }
    $C2: begin EcriM ('RETN '); Imm (16) end;

    { RETN (= RET 0) }
    $C3: begin
      EcriM ('RETN');
      if (FichExe=FALSE) and (not Eof(f)) then DemandeFin;
    end;

    { LES reg , imm(16) }
    $C4: begin EcriM ('LES '); LitO; Reg (16,rHAUT); EcriM (','); OfsVar (16) end;

    { LDS reg , imm (16) }
    $C5: begin EcriM ('LDS '); LitO; Reg (16,rHAUT); EcriM (','); OfsVar (32) end;

    { MOV seg:[ofst], imm(8/16) }
    $C6,$C7: begin EcriM ('MOV '); LitO;
      if fonction=$C7 then bits := 16 else bits := 8;

      OfsVar (bits);
      EcriM (',');
      Imm(bits)
    end;

    { ENTER imm(16),imm(8) }
    $C8: begin EcriM ('ENTER '); Imm (16); EcriM (','); Imm (8) end;

    { LEAVE }
    $C9: EcriM ('LEAVE');

    { RETF Imm (16) }
    $CA: begin EcriM ('RETF '); Imm (16) end;

    { RETF (0) }
    $CB: EcriM ('RETF');

    { INT 03h }
    $CC: begin EcriM ('INT '); CoulTexte(CoulImm); EcriM ('03h') end;

    { INT xxh }
    $CD: begin EcriM ('INT '); Imm (8) end;

    { INTO }
    $CE: EcriM ('INTO');

    { IRET }
    $CF: begin EcriM ('IRET'); if Reg386 then EcriM ('D') end;

    { SHL/SHR  reg/var(8/16) ,1 }
    $D0: FoncSHL ( 8,1);
    $D1: FoncSHL (16,1);

    { SHL/SHR  reg/var(8/16) ,CL }
    $D2: FoncSHL ( 8,0);
    $D3: FoncSHL (16,0);

    { AAM/AAD imm(8) }
    $D4: begin EcriM ('AAM '); Imm (8) end;
    $D5: begin EcriM ('AAD '); Imm (8) end;

    { XLAT }
    $D7: EcriM ('XLAT');

    { Co-processeur (16/32/64 bits) }
    $D8,$DA,$DC,$DE: begin LitO; EcriM ('f');
      if (fonction and 2=2) and (TmpO shr 6<>3) then EcriM ('i');

      Case fonction shr 1 and 3 of
      0,1: bits := 32;
      2: bits := 64;
      3: bits := 16;
      end;

      Case TmpO shr 3 and 7 of
      0: EcriM ('add');
      1: EcriM ('mul');
      2: EcriM ('com');
      3: EcriM ('comp');
      4: EcriM ('sub');
      5: EcriM ('subr');
      6: EcriM ('div');
      7: EcriM ('divr');
      end; if (fonction=$DE) and (TmpO shr 6=3) then EcriM ('p'); EcriM (' ');

      if TmpO shr 6=3 then begin
        if fonction=$D8 then begin CoulTexte (CoulReg); EcriM ('st,') end;
        RegFPU;
      end else OfsVar (bits);
    end;

    { Co-processeur (32 bits) }
    $D9: begin LitO; EcriM ('f');
      if (TmpO shr 6=3) and (TmpO and 63>15) then begin
        Case TmpO and 63 of
        16: EcriM ('nop');

        32: EcriM ('chs');
        33: EcriM ('abs');
        36: EcriM ('tst');
        37: EcriM ('xam');

        40: EcriM ('ld1');
        41: EcriM ('ldl2t');
        42: EcriM ('ldl2e');
        43: EcriM ('ldpi');
        44: EcriM ('ldlg2');
        45: EcriM ('ldln2');
        46: EcriM ('ldz');

        49: EcriM ('yl2x');
        50: EcriM ('ptan');
        51: EcriM ('patan');
        52: EcriM ('xtract');

        54: EcriM ('decstp');
        55: EcriM ('incstp');
        56: EcriM ('prem');
        57: EcriM ('yl2xp1');
        58: EcriM ('sqrt');
        59: EcriM ('sincos');
        60: EcriM ('rndint');
        61: EcriM ('scale');
        62: EcriM ('sin');
        63: EcriM ('cos');
        else begin
          str (TmpO and 63,txt);
          dec (EcranX);
          EcriMc ('db 0D9h,'+Hex8(TmpO)+TxtInconnu+' >'+txt,CoulInco)
        end end;
      end else begin
        bits := 32;

        Case TmpO shr 3 and 7 of
        0: EcriM ('ld');
        2: EcriM ('st');
        3: EcriM ('stp');
        4: EcriM ('ldenv');
        5: EcriM ('ldcw');
        6: begin if not Wait then EcriM ('n'); EcriM ('stenv') end;
        else begin
          str (TmpO shr 3 and 7,txt);
          EcriMc ('db 0D9h,'+Hex8(TmpO)+TxtInconnu+' >'+txt,CoulInco)
        end end; EcriM (' ');

        if TmpO shr 6=3 then RegFPU else OfsVar (bits);
      end;
    end;

    { fonction d'INITIALISATION du fpu }
    $DB: begin LitO; EcriM ('f');
      if TmpO shr 6=3 then begin
        if not Wait then EcriM ('n');
        Case TmpO and 7 of
        0: EcriM ('eni');
        1: EcriM ('disi');
        2: EcriM ('clex');
        3: EcriM ('init');
        4: EcriM ('setpm');
        else begin
          str (TmpO and 7,txt);
          EcriMc ('db 0DBh,'+Hex8(TmpO)+TxtInconnu+' >'+txt,CoulInco)
        end end;
      end else begin
        if 4<TmpO shr 3 and 7 then bits := 128 else bits := 32;

        Case TmpO shr 3 and 7 of
        0: EcriM ('ild');
        2: EcriM ('ist');
        3: EcriM ('istp');
        5: EcriM ('ld');
        7: EcriM ('stp');
        else begin
          str (TmpO shr 3 and 7,txt);
          EcriMc ('db 0DBh,'+Hex8(TmpO)+TxtInconnu+' >'+txt,CoulInco)
        end end; EcriM (' ');

        if TmpO shr 6=3 then RegFPU else OfsVar (bits);
      end;
    end;

    { fonction du fpu EN 64 BITS }
    $DD: begin LitO; EcriM ('f');
      Case TmpO shr 3 and 7 of
      0: EcriM ('ld');
      2: EcriM ('st');
      3: EcriM ('stp');
      4: EcriM ('rstor');
      6: begin if not Wait then EcriM ('n'); EcriM ('save') end;
      7: begin if not Wait then EcriM ('n'); EcriM ('stsw') end;
      else begin
        str (TmpO shr 3 and 7,txt);
        EcriMc ('db 0DDh,'+Hex8(TmpO)+TxtInconnu+' >'+txt,CoulInco)
      end end; EcriM (' ');

      if TmpO shr 3 and 7<4 then bits := 64 else bits := 32;

      if TmpO shr 6=3 then RegFPU else OfsVar (bits);
    end;

    { fadd,fmul,disu,didivr,... en 16/32/64 bits }
    $DF: begin LitO; EcriM ('f');

      bits := 16;

      Case TmpO shr 3 and 7 of
      0: EcriM ('ild');
      1: begin
        str (TmpO shr 3 and 7,txt);
        EcriMc ('db 0DFh,'+Hex8(TmpO)+TxtInconnu+'=1 >'+txt,CoulInco)
      end;
      2: EcriM ('ist');
      3: EcriM ('istp');
      4: begin EcriM ('bld');  bits := 128 end;
      5: begin EcriM ('ild');  bits :=  64 end;
      6: begin EcriM ('bstp'); bits := 128 end;
      7: begin EcriM ('istp'); bits :=  64 end;
      end; EcriM (' ');

      if TmpO shr 6=3 then RegFPU else OfsVar (bits);
    end;

    { LOOP(N)E short imm(8 sign) }
    $E0: begin EcriM ('LOOPNE '); JmpPtrD (8); ImmJmp (8,+2) end;
    $E1: begin EcriM ('LOOPE '); JmpPtrD (8); ImmJmp (8,+2) end;

    { LOOP short CS:imm(8 sign) }
    $E2: begin EcriM ('LOOP ');
      JmpPtr (8);
      CoulTexte(CoulSegm); EcriM ('CS:');
      CoulTexte(CoulComm); EcriM ('$');
      ImmJmp (8,+2);
    end;

    { JCXZ / JECXZ (si CX = 0) }
    $E3: begin if Ofs386 then EcriM ('JECXZ ') else EcriM ('JCXZ '); JmpPtrD(8); ImmJmp (8,+2) end;

    { IN/OUT  AL/AX,imm (8/16) }
    $E4,$E5: begin EcriM ('IN ');
      Ax (8);
      Virgule;
      if fonction=$E5 then Imm (16) else Imm (8);
    end;

    $E6,$E7: begin EcriM ('OUT ');
      Imm (8);
      Virgule;
      if fonction=$E7 then Ax(16) else Ax(8);
    end;

    { CALL near/far CS: immS (16bits) }
    $E8: begin
      EcriM ('CALL ');
      if PushCS then JmpPtr (32) else JmpPtr (16);
      CoulTexte(CoulSegm); EcriM ('CS:');
      CoulTexte(CoulComm); EcriM ('$');
      ImmJmp (16,+3);
    end;

    { JMP near/far CS: immS (16bits) }
    $E9: begin
      EcriM ('JMP '); JmpPtr (16);
      CoulTexte(CoulSegm); EcriM ('CS:');
      CoulTexte(CoulComm); EcriM ('$');
      ImmJmp (16,+3);
    end;

    { CALL CS:segm*16+ofst }
    $EA: begin EcriM ('JMP '); Pointeur end;

    { JMP short (8 sign) }
    $EB: begin EcriM ('JMP '); JmpPtrD (8); ImmJmp (8,+2) end;

    { IN AL/AX,DX }
    $EC,$ED: begin EcriM ('IN '); if TmpO=$ED then Ax(16) else Ax(8); Virgule; CoulTexte(CoulReg); EcriM ('DX') end;

    { OUT AL/AX,DX }
    $EE,$EF: begin EcriM ('OUT '); CoulTexte(CoulReg); EcriM ('DX'); Virgule; if TmpO=$EF then Ax(16) else Ax(8) end;

    { LOCK }
    $F0: EcriM ('LOCK');

    { REP (NZ) fonc }
    $F2,$F3: begin EcriM ('REP'); if TmpO=$F2 then EcriM ('NZ ') else EcriM ('Z ');
      LitO;

      TestPrefix;

      if Reg386 then key := 'D' else key := 'W';

      Case TmpO of
      $AA: EcriM ('STOSB');
      $AB: EcriM ('STOS'+key);
      $AC: EcriM ('LODSB');
      $AD: EcriM ('LODS'+key);
      $A4: EcriM ('MOVSB');
      $A5: EcriM ('MOVS'+key);
      $A6: EcriM ('CMPSB');
      $A7: EcriM ('CMPS'+key);
      $AE: EcriM ('SCASB');
      $AF: EcriM ('SCAS'+key);
      $6C: EcriM ('INSB');
      $6D: EcriM ('INS'+key);
      $6E: EcriM ('OUTSB');
      $6F: EcriM ('OUTS'+key);
      else begin
        str (TmpO,txt);
        EcriMc ('Table REP inconnue  = '+txt,CoulInco)
      end end;
    end;

    { HLT }
    $F4: EcriM ('HLT');

    { 'Flags On/Off (CMC,CLC,CLI,STI, CLS,STD,STC) }
    $F5 : EcriM ('CMC');
    $F8 : EcriM ('CLC');
    $F9 : EcriM ('STC');

    { TEST/NOT/MUL/..  reg/ofs/var(8/16) }
    $F6,$F7: begin LitO; if fonction=$F7 then bits := 16 else bits := 8;

      Case TmpO shr 3 and 7 of
      0: EcriM ('TEST');
      1: EcriMc ('db '+Hex8(fonction)+','+Hex8(TmpO)+TxtInconnu+' (F6/F7h) >1',CoulInco);
      2: EcriM ('NOT');
      3: EcriM ('NEG');
      4: EcriM ('MUL');
      5: EcriM ('IMUL');
      6: EcriM ('DIV');
      7: EcriM ('IDIV');
      end; EcriM (' ');

      if TmpO shr 6=3 then Reg (bits,NON) else OfsVar (bits);
      if TmpO shr 3 and 7=0 {TEST} then begin EcriM (','); Imm (bits) end;
    end;

    { 'Flags On/Off (CMC,CLC,CLI,STI, CLS,STD,STC) }
    $FA : EcriM ('CLI');
    $FB : EcriM ('STI');
    $FC : EcriM ('CLD');
    $FD : EcriM ('STD');

    { INC/PUSH/CALL/..  reg/ofs/var(8/16) }
    $FE,$FF: begin if fonction=$FF then bits := 16 else bits := 8;

      LitO;
      Case TmpO shr 3 and 7 of
      0: EcriM ('INC');
      1: EcriM ('DEC');
      2: EcriM ('CALL');
      3: begin EcriM ('CALL'); bits := 32 end;
      4: EcriM ('JMP');
      5: begin EcriM ('JMP');  bits := 32 end;
      6: EcriM ('PUSH');
      7: begin EcriM ('PUSH'); bits := 32 end;
      end; EcriM (' ');

      if TmpO shr 6=3 then Reg (bits,NON) else OfsVar (bits);
    end;

    { INCONNU = Variable ? Fonction inconnu ? }
    else begin
      CoulTexte (CoulInco); EcriM ('db ');

      { Remet les prfixes }
      if Reg386 then EcriM ('66h,');

      Case MovSeg[1] of
      'E'{S}: EcriM ('26h,');
      'C'{S}: EcriM ('2Eh,');
      'S'{S}: EcriM ('36h,');
      'D'{S}: EcriM ('3Eh,');
      'F'{S}: EcriM ('64h,');
      'G'{S}: EcriM ('65h,');
      end;

      if Ofs386 then EcriM ('67h,');
      if Wait   then EcriM ('9Bh,');
      if PushCS then EcriM ('0Eh,');

      EcriM (Hex8(fonction)+TxtInconnu);
    end end;

    { Sauve le nombre de code machine  cette ligne }
    with CopieXMS do begin
      Taille := 2;
      SrcHdl := EcranXmsHandle;
      SrcOfs := EcranY*SizeOf(LigneXms);
      DstHdl := 0;
      DstOfs := Ptr2Long(Tampon.Src);
    end;
    CopieMemXms (CopieXms);
    TestErreurXms ('criture du nombre de code machine (1/2)');
    Tampon.Src^[0] := CodeMachI;
    with CopieXMS do begin
      DstHdl := SrcHdl;
      DstOfs := SrcOfs;
      SrcHdl := 0;
      SrcOfs := Ptr2Long(Tampon.Src);
    end;
    CopieMemXms (CopieXms);
    TestErreurXms ('criture du nombre de code machine (2/2)');

    EcriMr ('');
  until (PosMaxFich<=PosFich+TamponFich.Pos);

  { Demande la pression d'une touche }
  EcriTxhc (0,AvancY-1,80,' ', 7+0*16);
  EcriTxhc (0,AvancY,80,  ' ', 7+0*16);
  EcriTxhc (0,AvancY+1,80,' ', 7+0*16);
  EcriTxhc (0,24,80,' ',14+4*16);
  EcriTxc (-1,24,'- Pressez une touche pour voir sa source -',14+4*16);
  LitTouche;

  EcranYmax := EcranY;
End;

procedure DeplaceEcranXms (plus: shortint); begin
  TmpL := EcranY +plus;
  if TmpL<0 then TmpL := 0;
  if EcranYmax-24<TmpL then TmpL := EcranYmax-24;
  if TmpL=EcranY then exit;

  EcranY := TmpL;
  AfficheEcranXms (EcranY);
end;

procedure Navigation; begin
  PosXY (0,24);
  EcranTxt.CoulTxt := 14+3*16;
  EcriTc ('۲ ',CoulAide);
  Ecrit ('F1 : Affiche l''aide');
  EcriTc (' ۲ ',CoulAide);
  Ecrit ('F2 : Explications');
  EcriTc (' ۲ ',CoulAide);
  Ecrit ('Echape : Quitter');
  EcriTc (' ',CoulAide); EcriTxc (79,24,'',CoulAide);

  EcranY := 0; AfficheEcranXms (0);
  repeat
    key := UpCase(LitTouche);
    Case key of
    _F1: AfficheAide;
    _F2: AfficheExplication;
    end;

    if 0<EcranYmax-24 then Case key of
    _DEBUT: begin EcranY := 0; AfficheEcranXms (EcranY) end;
    _FIN  : begin EcranY := EcranYmax-24; AfficheEcranXms (EcranY) end;
    _PAGEHAUT: DeplaceEcranXms (-24);
    _HAUT: DeplaceEcranXms (-1);
    _BAS:  DeplaceEcranXms (+1);
    _PAGEBAS:  DeplaceEcranXms (+24);
    end;
  until key=_ECHAPE;
end;

procedure Init; begin
  { Vrifie la prsence du driver XMS }
  VerifiePresenceXms;

  { Init. l'cran }
  EffaceEcranTxt; EcriTcr ('[ Initialisation ]',15+3*16);

  { Alloue de la mmoire }
  if MemAvail < $FFFF then begin
    EffaceEcranTxt;
    EcriTcr ('Pas assez de mmoire libre pour cre un double buffer !',12);
    Ecrit ('(manque ');
    EcriTnc ($FFFF - MemAvail,10); EcriTr (' octets)');
    Halt (8);
  end;
  with Tampon do begin GetMem (Src,$FFFF); Charge := TRUE end;

  { Demande le nom du fichier  dsassembler si il n'est pas fourni }
  if ParamStr(1)='' then begin
    EcriTcr ('Veuillez entrer le nom du fichier excutable que vous voulez dsassembler :',15);
    ReadLn (NomFich);
    EffaceEcranTxt;
  end else NomFich := ParamStr (1);
  CurseurOff;

  { Ajoute l'extension si non incluse (.exe par dfaut) }
  if Pos('.',NomFich)=0 then NomFich := NomFich +'.exe';

  { Sauve le nom du fichier sans l'extension }
  txt := NomFich;
  PosChr := Pos('\',Copy(txt,PosChr+1,length(txt)));
  while (Pos('\',Copy(txt,PosChr+1,length(txt)))<>0) do
    PosChr := Pos('\',Copy(txt,PosChr+1,length(txt)))+PosChr;
  NomFichComplet := Copy(txt,PosChr+1,length(txt));

  { Cherche l'extension du fichier }
  PosChr := Pos('.',NomFich);

  { Ouvre le fichier }
  OuvreFich (F, NomFich, '.exe');

  { Lit l'en-tte }
  BlockRead (f,TmpM,2); Reset (f,1);

  { Identifit son type (EXE ou COM) }
  if TmpM=ExeID then begin
    FichExe := TRUE;
    BlockRead (f,EnteteEXE,SizeOf(EnteteEXE));

    { Va au dbut du code }
    with EnTeteEXE do begin
      {$IFDEF AvecDebut}
      TmpL := DebutCode shr 16 *16 +DebutCode and $FFFF +OfstCode shl 4;
      if FileSize(F)<TmpL then
      {$ENDIF}
      TmpL := OfstCode shl 4;

      if FileSize(F)<TmpL then begin
        EcriTcr ('Erreur : dbut du fichier incorrect !',12);
        SauteLigne;
        Halt;
      end;

      PosDebutCode := TmpL;
      Seek (F, TmpL);
    end;
  end else FichExe := FALSE;

  { Cre la destination -> Si le fichier '.asm' n'existe pas sinon '.as2' }
  NomFich := Copy(NomFich,0,PosChr-1);
  PosChr := Pos('\',NomFich);
  if PosChr<>0 then begin
    while (Pos('\',Copy(NomFich,PosChr+1,length(NomFich)))<>0) do
      PosChr := Pos('\',Copy(NomFich,PosChr+1,length(NomFich)))+PosChr;

    Chemin := Copy(NomFich,1,PosChr);
    NomFich := Copy(NomFich,PosChr+1,length(NomFich));
  end else Chemin := '';

  { Sauve le nom du fichier de destination }
  NomFichDest := Chemin+NomFich;

  { Alloue l'cran XMS }
  TmpL := (FileSize(F)*SizeOf(LigneXms)) shr 10+1;

  { Taille trop peu importante ? (un minimum de 16Ko est requis) }
  if TmpL<16 then TmpL := 16;

  { Taille trop importante ? }
  if ($FFFF<TmpL) or ($FFFF<MemXmsLibre) then begin
    InitModeTxt;
    EcriTcr ('[ Erreur ]',14+4*16);
    Ecrit ('Le fichier '''); EcriTc (NomFichComplet,10); EcriT (''' a une ');
    EcriTc ('taille trop importante',14+4*16); EcriTr (' !');

    Ecrit ('Ce fichier a une taille de : ');
    EcriTnc (FileSize(F),10); EcriTr (' octets');

    Ecrit ('Or la taille maximale d''un fichier lisible est de : ');
    EcriTnc (LongInt(MemXmsLibre)*1000 div SizeOf(LigneXms),10); EcriTr (' octets');
    LitTouche;
    SauteLigne;
    Fin;
  end;

  Ecrit ('Alloue un l''cran virtuel de ');
  EcriTnc (TmpL,10); EcriTr ('Ko');
  EcranXmsHandle := AlloueMemXms (TmpL);
  TestErreurXms ('allouage de l''cran XMS');
  EcranXmsCharge := TRUE;
  TmpL := TmpL*1000;
  EcranYmax := TmpL;

  { Prpare la barre d'avancement }
  txt := 'Efface le contenue de l''cran virtuel : '; AvancPourc := $FF;
  EcriT (txt); EcriTc ('000',1); AvancX := EcranX; AvancY := EcranY; EcriTr ('%');
  AvancLarg := 80; EcriThc (AvancLarg,'',7 +CoulAvance and $F0);

  { Efface le contenu de l'cran XMS }
  fillchar (Tampon.Src^,$FFFE,0);
  with CopieXms do begin
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
    DstHdl := EcranXmsHandle;
    DstOfs := 0;
  end;

  repeat
    if $FFFE<TmpL then begin
      CopieXms.Taille := $FFFE;
      CopieMemXms (CopieXms);
      TestErreurXms ('init. de l''cran XMS');
      inc (CopieXms.DstOfs,$FFFE);
      dec (TmpL,$FFFE);
    end else begin
      if TmpL and 1=1 then inc(TmpL);
      CopieXms.Taille := TmpL;
      CopieMemXms (CopieXms);
      TestErreurXms ('init. de l''cran XMS');
      inc (CopieXms.DstOfs,TmpL);
      TmpL := 0;
    end;

    { Dessine la barre d'avancement }
    TmpO := round(CopieXms.DstOfs /EcranYmax *100);
    if TmpO<>AvancPourc then begin
      AvancPourc := TmpO;
      Avance := round(CopieXms.DstOfs /EcranYmax *AvancLarg);
      str (AvancPourc,txt); EcriTxc (AvancX-length(txt),AvancY,txt,14);
      EcriTxhc (0,AvancY+1,Avance,'',CoulAvance);
    end;
  until TmpL=0;
  EcriTxhc (0,AvancY+1,80,' ', 7+0*16);

  { Affiche les infos sur le fichier excutable }
  if FichEXE then AfficheInfoEXE else AfficheInfoCOM;

  { Init. le tampon de lecture dans le fichier excutable }
  with TamponFich do begin
    Pos    := TailleTamponFich;
    PosMax := TailleTamponFich;
  end;
  PosMaxFich := FileSize(f);

  DonneeOn := FALSE;
end;

procedure Fin; begin
  EffaceEcranTxt;
  EcranTxt.CoulTxt := 7+0*16;
  EcriTc ('DesAsm',15+1*16); EcriTc (' v',7+1*16); EcriTcr (Version,14+1*16);
  EcriT ('Crateur: '); EcriTcr ('Haypo ',10);
  EcriT ('Email   : '); EcriTcr (Email,10);
  EcriT ('Sources : '); EcriTcr (PageWeb,10);
  SauteLigne;
  LibereMemAlloue;
  CurseurOn;
  Close (F);
  Halt;
end;

Begin
  Init;

  DesassembleCode;

  Navigation;

  SauveASM;

  Fin;
end.