(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                      DasmFich.TPU                                  
                      ------------                                  
                                                                            
       Procdures de lecture dans le fichier pour le programme 'DesAsm'     
                                                                            
****************************************************************************
******** Pour plus informations consultez le fichier 'DesAsm.txt' **********
****************************************************************************
*)

unit DAsmFich;

{}
                               {} INTERFACE {}
{}

uses
  Convert,    { Pour l'affichage en hexadcimal }
  DasmXms,    { Pour l'cran virtuel (XMS) }
  Xms;        { Pour la mmoire tendue (XMS) }

procedure LitO;
procedure LitS;
procedure LitM;
procedure LitI;
procedure LitL;

const
  TailleTamponFich = 8192;   { Tampon de lectute dans le fichier de 8Ko }
  ExeID = $5A4D;         { Identificateur 'MZ' des fichier '.exe' }

var
  EnteteEXE : record
{Position}
{00} ID: array[0..1] of char; { Les deux caractres de reconnaissance : 'MZ' }
{02} OctetRestant     : Word; { Taille du fichier mod 512                    }
{04} NbrPage          : Word; { Taille du fichier div 512 (en page)          }
{06} NbrEntreeTable   : Word; { Nombre d'entre dans la table de translation }
{08} OfstCode         : Word; { Taille de l'en-tte et de la table de trans- }
                              { lation div 16 (en paragraphes)               }
{10} MemRecquise      : Word; { Taille de la mmoire requise immdiatement   }
                              { aprs les modules div 16 (en paragraphes).   }
                              { Si cette valeur est nulle, le maximum est    }
                              { demand                                      }
{12} MemPtetreRequise : Word; { Taille de la mmoire peut-tre requise juste }
                              { aprs le programme div 16 (en paragraphes)   }
{14} PtrDebutPile  : Pointer; { Pointeur sur le dbut de la pile (SS:SP)     }
{18} TotalDeControl   : Word; { Total de contrle complt                   }
{20} DebutCode     : LongInt; { Pointeur sur le dbut du code (CS:IP)        }
{24} PosTable         : Word; { Dplacement vers le dbut de la table de     }
                              { translation                                  }
{26} NumeroSegment    : Word; { Le numro du segment de recouvrement produit }
                              { par l'diteur de liens.                      }
{28} ToujoursEgalA1   : Word; { Toujours gal  0001h                        }
    end; { de 'EnteteEXE' }

  { Fichier }
  F: File;
  PosFich: LongInt;
  PosDebutCode: LongInt;

  { Tampon de lecture dans le fichier compil }
  TamponFich: record
    Src: array [0..TailleTamponFich-1] of byte;
    Pos,PosMax: LongInt;
  end;

  i,index: word;

  { Donnes lues dans le fichier }
  TmpO: byte;
  TmpS: shortint;
  TmpM: word;
  TmpI: integer;
  TmpL: longint;

  { Chaine de caractres }
  txt,TmpTxt: string;

{}
                            {} IMPLEMENTATION {}
{}

procedure AfficheLit (NOctets: byte); begin with CopieXms do begin
  { Lit nbr octets +1 }
  Taille := NOctets mod 100;
  if Taille and 1=1 then inc(Taille);
  SrcHdl := EcranXmsHandle;
  SrcOfs := EcranY*SizeOf(LigneXms)+OfsLigneXmsMach+CodeMachI;
  DstHdl := 0;
  DstOfs := Ptr2Long(Tampon.Src);
  CopieMemXms (CopieXms);
  TestErreurXms ('criture du code machine dans cran XMS (1/2)');

  { Dest }
  SrcHdl := 0;
  DstHdl := EcranXmsHandle;
  DstOfs := EcranY*SizeOf(LigneXms)+OfsLigneXmsMach+CodeMachI;

  Case NOctets of
  1: SrcOfs := Ptr2Long(Addr(TmpO));
  2: SrcOfs := Ptr2Long(Addr(TmpM));
  4: SrcOfs := Ptr2Long(Addr(TmpL));
  101: SrcOfs := Ptr2Long(Addr(TmpS));
  102: SrcOfs := Ptr2Long(Addr(TmpI));
  end;
  CopieMemXms (CopieXms);
  TestErreurXms ('criture du code machine dans cran XMS (2/2)');

  inc (CodeMachI,NOctets mod 100);
end end;

procedure ErreurTamponFich (NOctets: byte); begin
  str (NOctets,TmpTxt);
  TmpTxt := '*Lit '+TmpTxt+' octet';
  if 1<NOctets then TmpTxt := TmpTxt+'s';
  TmpTxt := TmpTxt +' hors du fichier*';
  EcriMc (TmpTxt,12);
{  TamponFich.Pos := 0;
  PosFich := FilePos(f);
  TamponFich.Pos := 0;
  PosFich := 1;
  TamponFich.Pos := FilePos(F)-1;
  TamponFich.Src[0] := 0;}
end;

procedure LitO; begin with TamponFich do begin
  if PosMax=Pos then begin
    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax<>0 then begin
      BlockRead (f,TamponFich.Src,PosMax);
      Pos := 0;
      PosFich := FilePos(f)-PosMax;
    end else ErreurTamponFich (1);
  end;
  TmpO := Src[Pos]; AfficheLit (1); inc (Pos);
end end;

procedure LitS; begin with TamponFich do begin
  if PosMax=Pos then begin
    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax<>0 then begin
      BlockRead (f,TamponFich.Src,PosMax);
      Pos := 0;
      PosFich := FilePos(f)-PosMax;
    end else ErreurTamponFich (101);
  end;
  TmpS := Src[Pos]; AfficheLit (101); inc (Pos);
end end;

procedure LitM; begin with TamponFich do begin
  if PosMax=Pos+1 then begin
    TmpM := Src[Pos];

    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax=0 then ErreurTamponFich (2);

    BlockRead (f,TamponFich.Src,PosMax);
    TmpM := TmpM+Word(Src[0]) shl 8; AfficheLit (2);

    Pos := 1;
    PosFich := FilePos(f)-PosMax;

    Exit;
  end;

  if PosMax=Pos then begin
    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax=0 then ErreurTamponFich (2);

    BlockRead (f,TamponFich.Src,PosMax);
    Pos := 0;
    PosFich := FilePos(f)-PosMax;
  end;
  TmpM := Src[Pos]+Word(Src[Pos+1]) shl 8; AfficheLit (2);
  inc (Pos,2);
end end;

procedure LitI; begin with TamponFich do begin
  if PosMax=Pos+1 then begin
    TmpI := Src[Pos];

    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax=0 then ErreurTamponFich (2);

    BlockRead (f,TamponFich.Src,PosMax);
    TmpI := TmpI+Word(Src[0]) shl 8; AfficheLit (102);

    Pos := 1;
    PosFich := FilePos(f)-PosMax;

    Exit;
  end;

  if PosMax=Pos then begin
    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax=0 then ErreurTamponFich (2);

    BlockRead (f,TamponFich.Src,PosMax);
    Pos := 0;
    PosFich := FilePos(f)-PosMax;
  end;
  TmpI := Src[Pos]+Word(Src[Pos+1]) shl 8; AfficheLit (102);
  inc (Pos,2);
end end;

procedure LitL; begin with TamponFich do begin
  if PosMax=Pos+3 then begin
    TmpL := Src[Pos]
           +LongInt(Src[Pos+1]) shl 8
           +LongInt(Src[Pos+2]) shl 16;

    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax=0 then ErreurTamponFich (2);

    BlockRead (f,TamponFich.Src,PosMax);

    TmpL := TmpL+
         +LongInt(Src[Pos]) shl 24;

    AfficheLit (4);

    Pos := 1;
    PosFich := FilePos(f)-PosMax;

    Exit;
  end;

  if PosMax=Pos+2 then begin
    TmpL := Src[Pos]+LongInt(Src[Pos+1]) shl 8;

    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax=0 then ErreurTamponFich (2);

    BlockRead (f,TamponFich.Src,PosMax);
    TmpL := TmpL+
         +LongInt(Src[Pos  ]) shl 16
         +LongInt(Src[Pos+1]) shl 24;
    AfficheLit (4);

    Pos := 1;
    PosFich := FilePos(f)-PosMax;

    Exit;
  end;

  if PosMax=Pos+1 then begin
    TmpL := Src[Pos];

    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax=0 then ErreurTamponFich (2);

    BlockRead (f,TamponFich.Src,PosMax);
    TmpL := TmpL+
         +LongInt(Src[Pos  ]) shl 8
         +LongInt(Src[Pos+1]) shl 16
         +LongInt(Src[Pos+2]) shl 24;
    AfficheLit (4);

    Pos := 1;
    PosFich := FilePos(f)-PosMax;

    Exit;
  end;

  if PosMax=Pos then begin
    if (FileSize(f) < FilePos (f)+TailleTamponFich) then
      PosMax := FileSize(f) - FilePos (f) else PosMax := TailleTamponFich;

    if PosMax=0 then ErreurTamponFich (2);

    BlockRead (f,TamponFich.Src,PosMax);
    Pos := 0;
    PosFich := FilePos(f)-PosMax;
  end;

  { Rq: La fin est ok }
  TmpL := LongInt(Src[Pos  ])
         +LongInt(Src[Pos+1]) shl 8
         +LongInt(Src[Pos+2]) shl 16
         +LongInt(Src[Pos+3]) shl 24;

  AfficheLit (4); inc (Pos,4);
end end;

{}
{                           CHARGEMENT DE L'UNITE                          }
{}

begin
  { Rien pour le dmarrage }
end.